pipeline {
    agent any
    
    stages {
        stage('Checkout') {
            steps {
                // Clone the Git repository
                git branch: 'master', credentialsId: 'jenkins', url: 'git@gitlab.com:faycel.benyounes/projet12.git'
            }
        }

   stage('Set Up Environment') {
            steps {
                // Set up Python virtual environment
                script {
                    sh "python${PYTHON_VERSION} -m venv ${VENV_NAME}"
                    sh "source ${VENV_NAME}/bin/activate"
                    sh "pip install --upgrade pip"
                    sh "pip install -r source_code/requirements.txt"
                }
            }
        }

        stage('Build') {
            steps {
                // Run your build commands
                script {
                    sh "python source_code/server.py build"
                }
            }
        }

        stage('Test') {
            steps {
                // Run your tests
                script {
                    sh "python server.py test"
                }
            }
        }
 

    stage('Docker') {
          steps {
              script{
                  sh "docker build -t flask-image:v1 ."
                  withCredentials([usernamePassword(credentialsId: 'dockerhub', usernameVariable: 'faycel.benyounes@orange.fr', passwordVariable: 'dckr_pat_74XcjwMX2EdlahH523xUApg44lY')]) {
                  sh "docker build -t flask-image:v1 ."
                  sh "docker tag flask-image:v1 faisalben/flask-image:v1"
                  sh "docker login -u 'faycel.benyounes@orange.fr' -p 'dckr_pat_74XcjwMX2EdlahH523xUApg44lY'"
                  sh "docker push 'faisalben/flask-image:v1'"
}
}

}
}
    stage('Deploy app on K8s') {
steps  {
script{
withKubeCredentials(kubectlCredentials: [[caCertificate: '', clusterName: 'demo1', contextName: '', credentialsId: 'kubjenkins', namespace: 'default', serverUrl: 'https://172.31.14.197:6443']]) {
sh "/usr/bin/kubectl apply -f $JENKINS_HOME/workspace/projet10/webapp-deployement.yml"
sh "/usr/bin/kubectl apply -f $JENKINS_HOME/workspace/projet10/webapp-service.yml"
}
}
}
}

}
}

